/*
    描述: 触摸穿透
    创建人: yjy
    创建时间: 2022.4.22
*/

import { _decorator, Component, Node, EventTouch, EventMouse } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('TouchThrough')
export class TouchThrough extends Component {
    protected onLoad() {
        this.node.on(Node.EventType.TOUCH_START, this.onTouchBegan, this, true);
        this.node.on(Node.EventType.TOUCH_MOVE, this.onTouchMoved, this, true);
        this.node.on(Node.EventType.TOUCH_END, this.onTouchEnded, this, true);
        this.node.on(Node.EventType.TOUCH_CANCEL, this.onTouchCancelled, this, true);
        this.node.on(Node.EventType.MOUSE_WHEEL, this.onMouseWheel, this, true);
    }

    protected onTouchBegan(event: EventTouch) {
        event.preventSwallow = true;
    }

    protected onTouchMoved(event: EventTouch) {
        event.preventSwallow = true;
    }

    protected onTouchEnded(event: EventTouch) {
        event.preventSwallow = true;
    }

    protected onTouchCancelled(event: EventTouch) {
        event.preventSwallow = true;
    }

    protected onMouseWheel(event: EventMouse) {
        event.preventSwallow = true;
    }
}
